<?php
namespace GopNext\Services;

use Zeedhi\Framework\DataSource;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO;

class PercentageAndStructureForBudgetService{
    public function __construct($entityManager, $environment){
        $this->connection = $entityManager->getConnection();
        $this->environment = $environment;
      }
      
      public function beginTransaction() {
        $this->connection->beginTransaction();
      }
      
      public function commit() {
        $this->connection->commit();
      }
      
      public function rollback() {
        $this->connection->rollback();
      }
      
      public function updateOperationalItem($params, $seq) {
        $query = "";
        
        if ($params['CDFILIAL'] === 'P') {
            unset($params["CDFILIAL"]);
            $query = "UPDATE PERCITEMGOP
                         SET VRPERCITEMGOP = :VRPERCITEMGOP,
                             CDOPERULTATU = :CDOPERADOR,
                             DTULTATU = SYSDATE
                       WHERE NRSEQITEMORCA = :NRSEQITEMORCA
                         AND NRORG = :NRORG";
        } else {
            if ($seq) {
                $query = "UPDATE PERCITFILGOP
                             SET VRPERCITEMGOP = :VRPERCITEMGOP,
                                 CDOPERULTATU = :CDOPERADOR,
                                 DTULTATU = SYSDATE
                           WHERE CDFILIAL = :CDFILIAL
                             AND NRSEQITEMORCA = :NRSEQITEMORCA
                             AND NRORG = :NRORG";
            } else {
                $query = "INSERT INTO PERCITFILGOP (NRPERCITFILGOP, CDFILIAL, NRSEQITEMORCA, DSITEMORCAMENTO, VRPERCITEMGOP,
                                                    DTINCLUSAO, CDOPERINCLUSAO, NRORG)
                               SELECT SEQ_PERCITFILGOP.NEXTVAL, :CDFILIAL, NRSEQITEMORCA, DSITEMORCAMENTO, :VRPERCITEMGOP,
                                      SYSDATE, :CDOPERADOR, NRORG
                                 FROM PERCITEMGOP
                                WHERE NRSEQITEMORCA = :NRSEQITEMORCA
                                  AND NRORG = :NRORG";
            }
        }

        try {
            $std = $this->connection->prepare($query);
            $std->execute($params);
        } catch (Exception $e){
            throw $e;
        };
    }
}